/* Produit matrice*vecteur                      */
/* Evaluation du temps d'execution              */  

public class TestProduitMatriceVecteur {

/* Fonction de creation d'une vecteur de double */
/* initialise avec des nombres aleatoires       */
/* compris dans l'intervalle [0.0,max]          */
/* et un chiffre apres la virgule               */

  static double [] initRandVecteur(int lignes,
                                     double max) {
    double [] tab = new double[lignes];
    for ( int i = 0 ; i < lignes ; i++ ) {
      tab[i] = ((int) (Math.random()*max*1000.0))/1000.0; }
    return tab;
  }

/* Fonction de creation d'une matrice de double */
/* initialise avec des nombres aleatoires       */
/* compris dans l'intervalle [0.0,max]          */
/* et un chiffre apres la virgule               */

  static double [][] initRandMatrice(int lignes,
                                     int colonnes,
                                     double max) {
    double [][] tab = new double[lignes][colonnes];
    for ( int i = 0 ; i < lignes ; i++ ) {
      for ( int j = 0 ; j < colonnes ; j++ ) {
        tab[i][j] = ((int) (Math.random()*max*1000.0))/1000.0; } }
    return tab;
  }

//////////////////////////////////////////////////
  
/* Fonction de calcul du produit d'une matrice */
/* carree de reel de taille n.n par un tableau */
/* de reel de taille n                         */
/* n quelconque                                */
/* Retour: Un tableau de reel de taille n      */

  static double [] produitMatriceVecteur(double [][] m,
                                         double [] v) {
    int n = v.length;
    double [] w = new double[n];
    for ( int i = 0 ; i < n ; i++ ) {
      w[i] = 0.0;
      for ( int j = 0 ; j < n ; j++ ) {
        w[i] = w[i] + m[i][j]*v[j]; } }
    return w;
  }
  
/* Fonction de calcul du produit d'une matrice */
/* carree de reel de taille n.n par un tableau */
/* de reel de taille n                         */
/* n quelconque                                */
/* Resultat: Un tableau de reel de taille n    */

  static void produitMatriceVecteur(double [][] m,
                                    double [] v,
                                    double [] w) {
    int n = v.length;
    for ( int i = 0 ; i < n ; i++ ) {
      w[i] = 0.0;
      for ( int j = 0 ; j < n ; j++ ) {
        w[i] = w[i] + m[i][j]*v[j]; } }
  }
  
  static void testsProduitMatriceVecteur(int temps,int ni,int nf,
                                         int inc) {
    Ecran.formater("%6s%12s%14s%22s%14s%12s%14s%22s%14s\n",
                   "Taille","Appels","Temps total","Temps moyen",
                   "o(n^2)",
                   "Appels","Temps total","Temps moyen","o(n^2)");
    for ( int n = ni ; n <= nf ; n = n+inc ) {
      double [][] m = initRandMatrice(n,n,10.0);
      double [] v = initRandVecteur(n,10.0);
      { double [] w = new double[n];
        Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          produitMatriceVecteur(m,v,w);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%12d%14d%22.3f%14.4f",
                       n,i,t,(double) t/i,
                       ((double) t/i)/((double) n*n)); }
      { Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        double [] w;
        do {
          w = produitMatriceVecteur(m,v);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Ecran.formater("%12d%14d%22.3f%14.4f\n",
                       i,t,(double) t/i,
                       ((double) t/i)/((double) n*n)); } }
  }

//////////////////////////////////////////////////
  
/* Programme principal                          */

  public static void main(String [] args) {
    Ecran.afficher("Nombre de secondes de test? ");
    int temps = Clavier.saisirInt();
    Ecran.afficher("Taille initiale? ");
    int ni = Clavier.saisirInt();
    Ecran.afficher("Taille finale  ? ");
    int nf = Clavier.saisirInt();
    Ecran.afficher("Increment      ? ");
    int inc = Clavier.saisirInt();
    testsProduitMatriceVecteur(temps,ni,nf,inc);
  }
}